/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_TRAFFICPARTICIPANTSTRUCT_H
#define DPC_IMPL_TYPE_TRAFFICPARTICIPANTSTRUCT_H

#include "impl_type_int16.h"
#include "dpc/impl_type_vector_objectstruct.h"

namespace dpc {
struct TrafficParticipantStruct {
    ::Int16 number_of_objects{ 0 };
    ::dpc::vector_ObjectStruct object_list;

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(number_of_objects);
        fun(object_list);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(number_of_objects);
        fun(object_list);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("number_of_objects", number_of_objects);
        fun("object_list", object_list);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("number_of_objects", number_of_objects);
        fun("object_list", object_list);
    }

    friend bool operator==(const ::dpc::TrafficParticipantStruct& lhs, const ::dpc::TrafficParticipantStruct& rhs) noexcept
    {
        return (lhs.number_of_objects == rhs.number_of_objects) && (lhs.object_list == rhs.object_list);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_TRAFFICPARTICIPANTSTRUCT_H
